#Importeren lybraries
import time
import os
import ftplib
import os.path
import socket
import shutil
import datetime

import qgis.utils
from qgis.utils import iface

#from qgis.core import *
from qgis.core import QgsApplication, QgsVectorLayer, QgsVectorFileWriter, QgsProject
from qgis.gui import QgsMessageBar

#from PyQt5.QtCore import *
from PyQt5.QtCore import QObject, pyqtSignal
from PyQt5.QtCore import Qt, QTimer, QSettings, QTranslator, qVersion, QCoreApplication

#from PyQt5.QtGui import *
#from PyQt5.QtWidgets import *
from PyQt5.QtWidgets import QMessageBox, QMainWindow, QAction, QMenu, QFileDialog, QProgressBar
from PyQt5.QtGui import QIcon

##=====================================##
class BFVWtools:
    """QGIS Plugin Implementation."""

    def __init__(self, iface):
        self.iface = iface
        
        """ initialize plugin directory """
        self.plugin_dir = os.path.dirname(__file__)
        
        """ initialize locale """
        locale = QSettings().value('locale/userLocale')[0:2]
        locale_path = os.path.join(self.plugin_dir, 'i18n', 'BFVWtools_{}.qm'.format(locale))

        if os.path.exists(locale_path):
            self.translator = QTranslator()
            self.translator.load(locale_path)

            if qVersion() > '4.3.3':
                QCoreApplication.installTranslator(self.translator)


        """ Declare instance attributes """
        self.actions = []
        self.menu = self.tr(u'&BFVW Tools')

        """ TODO: We are going to let the user set this up in a future iteration """
        self.toolbar = self.iface.addToolBar(u'BFVW tools')
        self.toolbar.setObjectName(u'BFVW tools')

        """Dialoogvensters configureren"""
        self.dlg = BFVWtoolsDialog()
        self.dlg1 = BFVWtoolsDialog1()
        self.dlg2 = BFVWtoolsDialog2()
        self.dlg3 = BFVWtoolsDialog3()

        """Button [Bladeren] klikbaar maken"""
        self.dlg1.pushButton_1.clicked.connect(self.select_output_file1)
        self.dlg2.pushButton_2.clicked.connect(self.select_output_file2)
        self.dlg2.pushButton_2a.clicked.connect(self.select_output_file2a)
        self.dlg3.pushButton_3.clicked.connect(self.select_output_file3)

    """ noinspection PyMethodMayBeStatic """
    def tr(self, message):
        """Get the translation for a string using Qt translation API.

        We implement this ourselves since we do not inherit QObject.

        :param message: String for translation.
        :type message: str, QString

        :returns: Translated version of message.
        :rtype: QString
        """
        # noinspection PyTypeChecker,PyArgumentList,PyCallByClass
        return QCoreApplication.translate('BFVW tools', message)
        
    def add_action(
        self,
        icon_path,
        text,
        callback,
        enabled_flag=True,
        add_to_menu=True,
        add_to_toolbar=True,
        status_tip=None,
        whats_this=None,
        parent=None):

    def initGui(self):
        icon_path = ":/plugins/BFVWtools/"
        self.add_action(icon_path + "/icon.png", text=self.tr(u'Configuratie'), 
        callback=self.run, parent=self.iface.mainWindow())
        self.action = QAction( QIcon( os.path.dirname(os.path.realpath(__file__)) + "/icon.png" ), "Configuratie", 
        self.iface.mainWindow() )
        self.action.triggered.connect(self.run)
        #QObject.connect(self.action, SIGNAL("triggered()"), self.run)

        #"""Create the menu entrie Update CSV data and toolbar icon inside the QGIS GUI."""
        self.add_action(icon_path + "/icon1.png", text=self.tr(u'Update CSV data'), 
        callback=self.run1, parent=self.iface.mainWindow())
        self.action1 = QAction( QIcon( os.path.dirname(os.path.realpath(__file__)) + "/icon1.png" ), "Update CSV data", 
        self.iface.mainWindow() )
        self.action.triggered.connect(self.run1)
        #QObject.connect(self.action1, SIGNAL("triggered()"), self.run1),

        #"""Create the menu entrie CSV naar Shape CSV data and toolbar icon inside the QGIS GUI."""
        self.add_action(icon_path + "/icon2.png", text=self.tr(u'CSV naar Shape'), 
        callback=self.run2, parent=self.iface.mainWindow())
        self.action2 = QAction( QIcon( os.path.dirname(os.path.realpath(__file__)) + "/icon2.png" ), "CSV naar Shape", 
        self.iface.mainWindow() )
        self.action.triggered.connect(self.run2)
        #QObject.connect(self.action2, SIGNAL("triggered()"), self.run2)

        #"""Create the menu entrie XXXXXXXXXX and toolbar icon inside the QGIS GUI."""
        self.add_action(icon_path + "/icon3.png", text=self.tr(u'XXXXXXXX'), 
        callback=self.run3, parent=self.iface.mainWindow())
        self.action3 = QAction( QIcon( os.path.dirname(os.path.realpath(__file__)) + "/icon3.png" ), "XXXXXXXX", 
        self.iface.mainWindow() )
        self.action.triggered.connect(self.run3)
        #QObject.connect(self.action3, SIGNAL("triggered()"), self.run3)


        #""" Add a custom menu """
        self.menu = QMenu( "&BFVW tools", self.iface.mainWindow().menuBar() )
        self.menu.setObjectName( "&BFVW tools" )
        actions = self.iface.mainWindow().menuBar().actions()
        lastAction = actions[-1]
        
        self.iface.mainWindow().menuBar().insertMenu( lastAction, self.menu )
        self.menu.addAction( self.action )        
        self.iface.mainWindow().menuBar().insertMenu( lastAction, self.menu )
        self.menu.addAction( self.action1 )
        self.iface.mainWindow().menuBar().insertMenu( lastAction, self.menu )
        self.menu.addAction( self.action2 )
        self.iface.mainWindow().menuBar().insertMenu( lastAction, self.menu )
        self.menu.addAction( self.action3 )

        #""" Remove a QGIS menu (e.g., the Edit menu) """
        editMenu = self.iface.editMenu()
        editMenu.menuAction().setVisible( False )


        #""" Add a custom toolbar """
        self.toolbar = self.iface.addToolBar( "Werkbalk BFVW tools" )
        self.toolbar.setObjectName( "BFVW tools" )
        self.toolbar.addAction( self.action )
        self.toolbar.addAction( self.action1 )
        self.toolbar.addAction( self.action2 )
        self.toolbar.addAction( self.action3 )

    def unload(self):
        #"""Removes the plugin menu item and icon from QGIS GUI."""
        for action in self.actions:
            self.iface.removePluginMenu(
                self.tr(u'&BFVW Tools'),
                action)
            self.iface.removeToolBarIcon(action)
                
        """" remove the toolbar """
        del self.toolbar

    #"""Use getSaveFileName for set file path or getExistingDirectory for set directory path"""    
      
    def select_output_file1(self):
        lastdir1 = QFileDialog.getExistingDirectory(self.dlg1, "Selecteer output directory ")
        QgsProject.instance().writeEntry("bfvwtools", "last_dir1", (lastdir1))
        self.dlg1.lineEdit_1.setText(lastdir1)
               
    def select_output_file2(self):
        lastdir2 = QFileDialog.getExistingDirectory(self.dlg2, "Selecteer output directory ")
        QgsProject.instance().writeEntry("bfvwtools", "last_dir2", (lastdir2))
        self.dlg2.lineEdit_2.setText(lastdir2)

    def select_output_file2a(self):
        lastdir2a = QFileDialog.getExistingDirectory(self.dlg2, "Selecteer output directory ")
        QgsProject.instance().writeEntry("bfvwtools", "last_dir2a", (lastdir2a))
        self.dlg2.lineEdit_2a.setText(lastdir2a)
       
    def select_output_file3(self):
        lastdir3 = QFileDialog.getExistingDirectory(self.dlg3, "Selecteer output xxx ")
        QgsProject.instance().writeEntry("bfvwtools", "last_dir3", (lastdir3))
        self.dlg3.lineEdit_3.setText(lastdir3)

    """def select_output_file4(self):
        filename4 = QFileDialog.getSaveFileName(self.dlg4, "Selecteer output file ","", '*.ext')
        QgsProject.instance().writeEntry("bfvwtools", "filename4", (filename4))
        self.dlg4.lineEdit_4.setText(filename4)"""









project = "gggg"
host = "12"
user = "12"
passw = "12"

if project == "":
    iface.messageBar().pushMessage("Let op !!!", "Er is nog geen project geladen !!!", level=Qgis.Critical)
    
if host == "" or user == "" or passw == "":
    iface.messageBar().pushMessage("Let op !!!", "U heeft nog niet alle configuratie gegevens ingevoerd !!!", level=Qgis.Critical)

else:
    #"""Get setting from project file and fill lineEdit textbar"""
    self.dlg3.lineEdit_3.clear()
    last_dir3 = QgsProject.instance().readEntry("bfvwtools", 'last_dir3', "Blader naar uw CSV directory")[0]
    self.dlg3.lineEdit_3.setText(str(last_dir3))
    #"""Show the dialog"""            
    self.dlg3.show()
    #"""Run the dialog event loop"""
    result = self.dlg3.exec_()
    #"""See if OK was pressed"""
    if result:
        import time
        #Show processbar
        widget = self.iface.messageBar().createMessage("Een moment a.u.b."," Downloading CSV files . . .")
        prgBar = QProgressBar()
        prgBar.setAlignment(Qt.AlignLeft)
        prgBar.setValue(0)
        prgBar.setMaximum(100)           
        widget.layout().addWidget(prgBar)
        self.iface.messageBar().pushWidget(widget, self.iface.messageBar().WARNING)

        #for i in range(1,50):
            #time.sleep(0.1) 
            #prgBar.setValue(i + 1)"""

        prgBar.setValue(10)
        time.sleep(0.1)
        prgBar.setValue(20)
        time.sleep(0.1)
        prgBar.setValue(30)
        time.sleep(0.1)
        prgBar.setValue(40)
        time.sleep(0.1)
        prgBar.setValue(50)
        time.sleep(0.1)
        prgBar.setValue(60)
        time.sleep(0.1)
        prgBar.setValue(70)
        time.sleep(0.1)
        prgBar.setValue(80)
        time.sleep(0.1)
        prgBar.setValue(90)
        time.sleep(0.1)
        prgBar.setValue(100)
        time.sleep(0.1)
                
        self.iface.messageBar().clearWidgets()
        self.iface.mapCanvas().refresh()
           
    QMessageBox.information( self.iface.mainWindow(), "XXXXXXXX", 
        "XXXXXXXX is klaar!", QMessageBox.Ok )

###-------------------- xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx --------------------###
  